/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2015 Frederik Heber. All rights reserved.
 *
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * GlobalObservableInfo.cpp
 *
 *  Created on: Jul 4, 2015
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/MemDebug.hpp"

#include "CodePatterns/Observer/GlobalObservableInfo.hpp"

#include "CodePatterns/Assert.hpp"
#include "CodePatterns/Singleton_impl.hpp"

// static (simple) entities
range<int> GlobalObservableInfo::PriorityLevel::ValidRange(-20, 21);
const GlobalObservableInfo::PriorityLevel GlobalObservableInfo::PriorityDefault((int)0);

GlobalObservableInfo::GlobalObservableInfo()
{}

GlobalObservableInfo::~GlobalObservableInfo()
{}

GlobalObservableInfo::PriorityLevel::PriorityLevel(const int i) :
    level(i)
{
  ASSERT(ValidRange.isInRange(level),
      "GlobalObservableInfo::PriorityLevel::PriorityLevel() - Priority level "
      +toString(level)+" out of range "+toString(ValidRange)+".");
}

GlobalObservableInfo::PriorityLevel::~PriorityLevel()
{}


CONSTRUCT_SINGLETON(GlobalObservableInfo)
